'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _formsyReact = require('formsy-react-2');

var _formsyReact2 = _interopRequireDefault(_formsyReact);

var _TextField = require('material-ui/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _lodash = require('lodash.debounce');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * FormsyText is a wrapper around Material UI's [Text Field](http://www.material-ui.com/#/components/text-field) component.
 */
var FormsyText = function (_Formsy$Mixin) {
  (0, _inherits3.default)(FormsyText, _Formsy$Mixin);

  function FormsyText(props) {
    (0, _classCallCheck3.default)(this, FormsyText);

    var _this = (0, _possibleConstructorReturn3.default)(this, (FormsyText.__proto__ || (0, _getPrototypeOf2.default)(FormsyText)).call(this, props));

    var value = 'value' in props ? props.value : props.defaultValue;

    _this.state = (0, _assign2.default)(_this.state, {
      _value: value,
      _pristineValue: value
    });
    return _this;
  }

  (0, _createClass3.default)(FormsyText, [{
    key: 'handleBlur',
    value: function handleBlur(event) {
      this.changeValue && this.changeValue.cancel();
      delete this.changeValue;
      this.setValue(event.target.value);
      if (this.props.onBlur) this.props.onBlur(event);
    }
  }, {
    key: 'handleChange',
    value: function handleChange(event, value) {
      if (this.props.updateImmediately) {
        if (!this.changeValue) {
          this.changeValue = (0, _lodash2.default)(this.setValue, 400);
        }
        this.changeValue(value);
      } else if (this.isValidValue(value)) {
        this.setValue(value);
      }

      this.setState({ _value: value });
      if (this.props.onChange) this.props.onChange(event, value);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _removeFormsyProps = this.removeFormsyProps(this.props),
          defaultValue = _removeFormsyProps.defaultValue,
          updateImmediately = _removeFormsyProps.updateImmediately,
          value = _removeFormsyProps.value,
          rest = (0, _objectWithoutProperties3.default)(_removeFormsyProps, ['defaultValue', 'updateImmediately', 'value']);

      var props = (0, _assign2.default)({ disabled: this.isFormDisabled() }, rest);

      var formValue = this.getValue() || '';

      return _react2.default.createElement(_TextField2.default, (0, _extends3.default)({}, props, {
        errorText: this.getErrorMessage(),
        onBlur: function onBlur(e) {
          _this2.handleBlur(e);
        },
        onChange: function onChange(e, v) {
          _this2.handleChange(e, v);
        },
        value: formValue
      }));
    }
  }]);
  return FormsyText;
}(_formsyReact2.default.Mixin);

FormsyText.propTypes = {
  /**
   * The text string to use for the default value.
   * **Warning:** This cannot be used in conjunction with `value`.
   * Decide between using a controlled or uncontrolled input element and remove one of these props.
   * If `value` is provided it will override this prop.
   * @type {[type]}
   */
  defaultValue: _propTypes2.default.any,

  /**
   * @ignore
   */
  onBlur: _propTypes2.default.func,

  /**
   * Callback function that is fired when the textfield's value changes.
   * @param {Object} event `change` Change event targeting the text field.
   * @param {String} value The new value of the text field.
   */
  onChange: _propTypes2.default.func,

  /**
   * If true, the value of the TextField will be updated immediately on keypress.
   * This also means the TextField will be validated as the user is still typing.
   * If false, the value is only updated onBlur in order to improve performance
   * and to avoid displaying an error message to the user as they are typing.
   * Defaults to false.
   *
   * @type {[type]}
   */
  updateImmediately: _propTypes2.default.bool,

  /**
   * The value of the text field.
   * @type {[type]}
   */
  value: _propTypes2.default.any
};

FormsyText.defaultProps = {
  updateImmediately: false
};

exports.default = FormsyText;