'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _formsyReact = require('formsy-react-2');

var _formsyReact2 = _interopRequireDefault(_formsyReact);

var _TimePicker = require('material-ui/TimePicker');

var _TimePicker2 = _interopRequireDefault(_TimePicker);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * FormsyTime is a wrapper around Material UI's [Time Picker](http://www.material-ui.com/#/components/time-picker) component.
 */
var FormsyTime = function (_Formsy$Mixin) {
  (0, _inherits3.default)(FormsyTime, _Formsy$Mixin);

  function FormsyTime(props) {
    (0, _classCallCheck3.default)(this, FormsyTime);

    var _this = (0, _possibleConstructorReturn3.default)(this, (FormsyTime.__proto__ || (0, _getPrototypeOf2.default)(FormsyTime)).call(this, props));

    var time = 'value' in props ? props.value : props.defaultTime;

    _this.state = (0, _assign2.default)(_this.state, {
      _value: time,
      _pristineValue: time
    });
    return _this;
  }

  (0, _createClass3.default)(FormsyTime, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value) {
        if (!this.props.value || !(0, _utils.datesEq)(this.props.value, nextProps.value)) {
          this.setValue(nextProps.value);
        }
      } else if (nextProps.defaultTime) {
        if (!(0, _utils.datesEq)(this.props.defaultTime, nextProps.defaultTime)) {
          this.setValue(nextProps.defaultTime);
        }
      }
    }
  }, {
    key: 'handleChange',
    value: function handleChange(event, value) {
      this.setValue(value);
      if (this.props.onChange) this.props.onChange(event, value);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _removeFormsyProps = this.removeFormsyProps(this.props),
          defaultTime = _removeFormsyProps.defaultTime,
          onChange = _removeFormsyProps.onChange,
          value = _removeFormsyProps.value,
          rest = (0, _objectWithoutProperties3.default)(_removeFormsyProps, ['defaultTime', 'onChange', 'value']);

      var props = (0, _assign2.default)({ disabled: this.isFormDisabled() }, rest);

      return _react2.default.createElement(_TimePicker2.default, (0, _extends3.default)({}, props, {
        errorText: this.getErrorMessage(),
        onChange: function onChange(e, v) {
          _this2.handleChange(e, v);
        },
        value: this.getValue()
      }));
    }
  }]);
  return FormsyTime;
}(_formsyReact2.default.Mixin);

FormsyTime.propTypes = {
  /**
   * The default time of the Time component.
   * **Warning:** This cannot be used in conjunction with `value`.
   * Decide between using a controlled or uncontrolled input element and remove one of these props.
   * If `value` is provided it will override this prop.
   * @type {[type]}
   */
  defaultTime: _propTypes2.default.instanceOf(Date),

  /**
   * Callback function that is fired when the time value changes.
   * @type {[type]}
   * @param {Null} null Since there is no particular event associated with the change, the first argument will always be null.
   * @param {Date} value  The new time value.
   */
  onChange: _propTypes2.default.func,

  /**
   * Sets the time for the Time Picker.
   * @type {[type]}
   */
  value: _propTypes2.default.instanceOf(Date)
};

exports.default = FormsyTime;